/*
Copyright 2018 The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package internalversion

import (
	servicecatalog "github.com/kubernetes-incubator/service-catalog/pkg/apis/servicecatalog"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// ServiceInstanceLister helps list ServiceInstances.
type ServiceInstanceLister interface {
	// List lists all ServiceInstances in the indexer.
	List(selector labels.Selector) (ret []*servicecatalog.ServiceInstance, err error)
	// ServiceInstances returns an object that can list and get ServiceInstances.
	ServiceInstances(namespace string) ServiceInstanceNamespaceLister
	ServiceInstanceListerExpansion
}

// serviceInstanceLister implements the ServiceInstanceLister interface.
type serviceInstanceLister struct {
	indexer cache.Indexer
}

// NewServiceInstanceLister returns a new ServiceInstanceLister.
func NewServiceInstanceLister(indexer cache.Indexer) ServiceInstanceLister {
	return &serviceInstanceLister{indexer: indexer}
}

// List lists all ServiceInstances in the indexer.
func (s *serviceInstanceLister) List(selector labels.Selector) (ret []*servicecatalog.ServiceInstance, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*servicecatalog.ServiceInstance))
	})
	return ret, err
}

// ServiceInstances returns an object that can list and get ServiceInstances.
func (s *serviceInstanceLister) ServiceInstances(namespace string) ServiceInstanceNamespaceLister {
	return serviceInstanceNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// ServiceInstanceNamespaceLister helps list and get ServiceInstances.
type ServiceInstanceNamespaceLister interface {
	// List lists all ServiceInstances in the indexer for a given namespace.
	List(selector labels.Selector) (ret []*servicecatalog.ServiceInstance, err error)
	// Get retrieves the ServiceInstance from the indexer for a given namespace and name.
	Get(name string) (*servicecatalog.ServiceInstance, error)
	ServiceInstanceNamespaceListerExpansion
}

// serviceInstanceNamespaceLister implements the ServiceInstanceNamespaceLister
// interface.
type serviceInstanceNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all ServiceInstances in the indexer for a given namespace.
func (s serviceInstanceNamespaceLister) List(selector labels.Selector) (ret []*servicecatalog.ServiceInstance, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*servicecatalog.ServiceInstance))
	})
	return ret, err
}

// Get retrieves the ServiceInstance from the indexer for a given namespace and name.
func (s serviceInstanceNamespaceLister) Get(name string) (*servicecatalog.ServiceInstance, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(servicecatalog.Resource("serviceinstance"), name)
	}
	return obj.(*servicecatalog.ServiceInstance), nil
}
